blob: 23d965f327b5a4276f9e4fc1ba3daa8c4313fb4d [file] [log] [blame]
Linus Torvalds7ef76922005-05-22 11:03:24 -07001#!/bin/sh
2#
freku045@student.liu.se87358b72005-12-13 23:30:31 +01003
4USAGE='<fetch-options> <repository> <refspec>...'
Junio C Hamanoae2b0f12005-11-24 00:12:11 -08005. git-sh-setup
Junio C Hamano215a7ad2005-09-07 17:26:23 -07006. git-parse-remote
Junio C Hamano853a3692005-08-20 02:54:34 -07007_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
Linus Torvaldsb33e9662005-07-08 10:57:21 -07009
Junio C Hamano221e7432005-10-10 23:22:02 -070010LF='
11'
12IFS="$LF"
13
Junio C Hamano03febf92006-01-07 00:48:04 -080014no_tags=
Linus Torvaldsed1aadf2005-09-29 14:35:15 -070015tags=
Junio C Hamano853a3692005-08-20 02:54:34 -070016append=
Junio C Hamanoae2da402005-08-22 21:28:33 -070017force=
Linus Torvalds583122c2005-11-18 08:31:55 -080018verbose=
Junio C Hamanob10ac502005-08-25 18:15:32 -070019update_head_ok=
Michal Ostrowski2c620a12006-01-20 13:05:24 -050020exec=
Michal Ostrowski96b086d2006-01-20 13:38:16 -050021upload_pack=
Junio C Hamanoae2da402005-08-22 21:28:33 -070022while case "$#" in 0) break ;; esac
23do
24 case "$1" in
25 -a|--a|--ap|--app|--appe|--appen|--append)
26 append=t
Junio C Hamanoae2da402005-08-22 21:28:33 -070027 ;;
Junio C Hamano2796a9d2006-01-26 18:11:06 -080028 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
29 --upload-pa|--upload-pac|--upload-pack)
Michal Ostrowski2c620a12006-01-20 13:05:24 -050030 shift
31 exec="--exec=$1"
Michal Ostrowski96b086d2006-01-20 13:38:16 -050032 upload_pack="-u $1"
Michal Ostrowski2c620a12006-01-20 13:05:24 -050033 ;;
Junio C Hamanoae2da402005-08-22 21:28:33 -070034 -f|--f|--fo|--for|--forc|--force)
35 force=t
Junio C Hamanob10ac502005-08-25 18:15:32 -070036 ;;
Linus Torvaldsed1aadf2005-09-29 14:35:15 -070037 -t|--t|--ta|--tag|--tags)
38 tags=t
39 ;;
Junio C Hamano03febf92006-01-07 00:48:04 -080040 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
41 no_tags=t
42 ;;
Junio C Hamanob10ac502005-08-25 18:15:32 -070043 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
44 --update-he|--update-hea|--update-head|--update-head-|\
45 --update-head-o|--update-head-ok)
46 update_head_ok=t
Junio C Hamanoae2da402005-08-22 21:28:33 -070047 ;;
Linus Torvalds583122c2005-11-18 08:31:55 -080048 -v|--verbose)
49 verbose=Yes
50 ;;
Tom Prince0f76f522006-01-10 18:50:19 -070051 -k|--k|--ke|--kee|--keep)
52 keep=--keep
53 ;;
freku045@student.liu.se87358b72005-12-13 23:30:31 +010054 -*)
55 usage
56 ;;
Junio C Hamanoae2da402005-08-22 21:28:33 -070057 *)
58 break
59 ;;
60 esac
Junio C Hamanob10ac502005-08-25 18:15:32 -070061 shift
Junio C Hamanoae2da402005-08-22 21:28:33 -070062done
63
Junio C Hamano853a3692005-08-20 02:54:34 -070064case "$#" in
650)
Junio C Hamano92c533e2005-08-20 03:00:03 -070066 test -f "$GIT_DIR/branches/origin" ||
67 test -f "$GIT_DIR/remotes/origin" ||
Junio C Hamanob10ac502005-08-25 18:15:32 -070068 die "Where do you want to fetch from today?"
Junio C Hamano92c533e2005-08-20 03:00:03 -070069 set origin ;;
Junio C Hamano853a3692005-08-20 02:54:34 -070070esac
Junio C Hamanoae2da402005-08-22 21:28:33 -070071
Junio C Hamano853a3692005-08-20 02:54:34 -070072remote_nick="$1"
73remote=$(get_remote_url "$@")
74refs=
75rref=
76rsync_slurped_objects=
Linus Torvalds7ef76922005-05-22 11:03:24 -070077
Junio C Hamano853a3692005-08-20 02:54:34 -070078if test "" = "$append"
79then
Santi_Béjardf342972005-10-05 18:58:10 +020080 : >"$GIT_DIR/FETCH_HEAD"
Junio C Hamano853a3692005-08-20 02:54:34 -070081fi
82
83append_fetch_head () {
84 head_="$1"
85 remote_="$2"
86 remote_name_="$3"
87 remote_nick_="$4"
88 local_name_="$5"
Junio C Hamano05dd8e22005-09-25 22:54:23 -070089 case "$6" in
90 t) not_for_merge_='not-for-merge' ;;
91 '') not_for_merge_= ;;
92 esac
Junio C Hamano853a3692005-08-20 02:54:34 -070093
Junio C Hamano06ec2b42005-09-02 02:34:13 -070094 # remote-nick is the URL given on the command line (or a shorthand)
95 # remote-name is the $GIT_DIR relative refs/ path we computed
96 # for this refspec.
97 case "$remote_name_" in
98 HEAD)
99 note_= ;;
100 refs/heads/*)
101 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
Junio C Hamanob91fb512005-09-21 13:59:54 -0700102 note_="branch '$note_' of " ;;
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700103 refs/tags/*)
104 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
Junio C Hamanob91fb512005-09-21 13:59:54 -0700105 note_="tag '$note_' of " ;;
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700106 *)
Junio C Hamanob91fb512005-09-21 13:59:54 -0700107 note_="$remote_name of " ;;
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700108 esac
Junio C Hamanob91fb512005-09-21 13:59:54 -0700109 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
110 remote_="$remote_1_"
111 note_="$note_$remote_"
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700112
Junio C Hamano853a3692005-08-20 02:54:34 -0700113 # 2.6.11-tree tag would not be happy to be fed to resolve.
114 if git-cat-file commit "$head_" >/dev/null 2>&1
115 then
Junio C Hamano8572aa82005-08-24 22:46:07 -0700116 headc_=$(git-rev-parse --verify "$head_^0") || exit
Santi_Béjardf342972005-10-05 18:58:10 +0200117 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
Linus Torvalds583122c2005-11-18 08:31:55 -0800118 [ "$verbose" ] && echo >&2 "* committish: $head_"
119 [ "$verbose" ] && echo >&2 " $note_"
Junio C Hamano853a3692005-08-20 02:54:34 -0700120 else
Santi_Béjardf342972005-10-05 18:58:10 +0200121 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
Linus Torvalds583122c2005-11-18 08:31:55 -0800122 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
123 [ "$verbose" ] && echo >&2 " $note_"
Junio C Hamano853a3692005-08-20 02:54:34 -0700124 fi
125 if test "$local_name_" != ""
126 then
127 # We are storing the head locally. Make sure that it is
128 # a fast forward (aka "reverse push").
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700129 fast_forward_local "$local_name_" "$head_" "$note_"
Junio C Hamano853a3692005-08-20 02:54:34 -0700130 fi
131}
132
133fast_forward_local () {
Junio C Hamano866ff2f2005-09-10 10:40:47 -0700134 mkdir -p "$(dirname "$GIT_DIR/$1")"
Junio C Hamano853a3692005-08-20 02:54:34 -0700135 case "$1" in
136 refs/tags/*)
137 # Tags need not be pointing at commits so there
138 # is no way to guarantee "fast-forward" anyway.
Junio C Hamanoae2da402005-08-22 21:28:33 -0700139 if test -f "$GIT_DIR/$1"
140 then
Junio C Hamanof8765792005-10-18 18:42:14 -0700141 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
142 then
Linus Torvalds583122c2005-11-18 08:31:55 -0800143 [ "$verbose" ] && echo >&2 "* $1: same as $3"
Junio C Hamanof8765792005-10-18 18:42:14 -0700144 else
145 echo >&2 "* $1: updating with $3"
146 fi
Junio C Hamanoae2da402005-08-22 21:28:33 -0700147 else
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700148 echo >&2 "* $1: storing $3"
Junio C Hamanoae2da402005-08-22 21:28:33 -0700149 fi
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700150 git-update-ref "$1" "$2"
151 ;;
Junio C Hamanoae2da402005-08-22 21:28:33 -0700152
Junio C Hamano853a3692005-08-20 02:54:34 -0700153 refs/heads/*)
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700154 # $1 is the ref being updated.
155 # $2 is the new value for the ref.
156 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
157 if test "$local"
Junio C Hamano853a3692005-08-20 02:54:34 -0700158 then
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700159 # Require fast-forward.
Junio C Hamano853a3692005-08-20 02:54:34 -0700160 mb=$(git-merge-base "$local" "$2") &&
161 case "$2,$mb" in
162 $local,*)
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700163 echo >&2 "* $1: same as $3"
Junio C Hamano853a3692005-08-20 02:54:34 -0700164 ;;
165 *,$local)
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700166 echo >&2 "* $1: fast forward to $3"
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700167 git-update-ref "$1" "$2" "$local"
Junio C Hamano853a3692005-08-20 02:54:34 -0700168 ;;
169 *)
170 false
171 ;;
172 esac || {
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700173 echo >&2 "* $1: does not fast forward to $3;"
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700174 case ",$force,$single_force," in
175 *,t,*)
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700176 echo >&2 " forcing update."
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700177 git-update-ref "$1" "$2" "$local"
Junio C Hamanoae2da402005-08-22 21:28:33 -0700178 ;;
179 *)
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700180 echo >&2 " not updating."
Junio C Hamanoae2da402005-08-22 21:28:33 -0700181 ;;
182 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700183 }
184 else
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700185 echo >&2 "* $1: storing $3"
186 git-update-ref "$1" "$2"
Junio C Hamano853a3692005-08-20 02:54:34 -0700187 fi
Linus Torvalds0a623e72005-07-05 11:38:37 -0700188 ;;
Junio C Hamano853a3692005-08-20 02:54:34 -0700189 esac
190}
191
Junio C Hamanob10ac502005-08-25 18:15:32 -0700192case "$update_head_ok" in
193'')
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700194 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
Junio C Hamanob10ac502005-08-25 18:15:32 -0700195 ;;
196esac
197
Linus Torvaldsed1aadf2005-09-29 14:35:15 -0700198# If --tags (and later --heads or --all) is specified, then we are
199# not talking about defaults stored in Pull: line of remotes or
200# branches file, and just fetch those and refspecs explicitly given.
201# Otherwise we do what we always did.
202
203reflist=$(get_remote_refs_for_fetch "$@")
204if test "$tags"
205then
Junio C Hamano81214e42006-01-05 19:42:12 -0800206 taglist=$(IFS=" " &&
Michal Ostrowski96b086d2006-01-20 13:38:16 -0500207 git-ls-remote $upload_pack --tags "$remote" |
Junio C Hamano81214e42006-01-05 19:42:12 -0800208 while read sha1 name
209 do
210 case "$name" in
211 (*^*) continue ;;
212 esac
213 if git-check-ref-format "$name"
214 then
215 echo ".${name}:${name}"
216 else
217 echo >&2 "warning: tag ${name} ignored"
218 fi
219 done)
Linus Torvaldsed1aadf2005-09-29 14:35:15 -0700220 if test "$#" -gt 1
221 then
222 # remote URL plus explicit refspecs; we need to merge them.
Junio C Hamano221e7432005-10-10 23:22:02 -0700223 reflist="$reflist$LF$taglist"
Linus Torvaldsed1aadf2005-09-29 14:35:15 -0700224 else
225 # No explicit refspecs; fetch tags only.
226 reflist=$taglist
227 fi
228fi
229
Junio C Hamano03febf92006-01-07 00:48:04 -0800230fetch_main () {
231 reflist="$1"
232 refs=
Junio C Hamano853a3692005-08-20 02:54:34 -0700233
Junio C Hamano03febf92006-01-07 00:48:04 -0800234 for ref in $reflist
235 do
236 refs="$refs$LF$ref"
Junio C Hamano853a3692005-08-20 02:54:34 -0700237
Junio C Hamano03febf92006-01-07 00:48:04 -0800238 # These are relative path from $GIT_DIR, typically starting at refs/
239 # but may be HEAD
240 if expr "$ref" : '\.' >/dev/null
241 then
242 not_for_merge=t
243 ref=$(expr "$ref" : '\.\(.*\)')
244 else
245 not_for_merge=
246 fi
247 if expr "$ref" : '\+' >/dev/null
248 then
249 single_force=t
250 ref=$(expr "$ref" : '\+\(.*\)')
251 else
252 single_force=
253 fi
254 remote_name=$(expr "$ref" : '\([^:]*\):')
255 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
Junio C Hamano853a3692005-08-20 02:54:34 -0700256
Junio C Hamano03febf92006-01-07 00:48:04 -0800257 rref="$rref$LF$remote_name"
Junio C Hamano4447bad2005-09-17 11:56:41 -0700258
Junio C Hamano03febf92006-01-07 00:48:04 -0800259 # There are transports that can fetch only one head at a time...
260 case "$remote" in
261 http://* | https://*)
262 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
263 curl_extra_args="-k"
264 fi
265 remote_name_quoted=$(perl -e '
266 my $u = $ARGV[0];
267 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
268 print "$u";
269 ' "$remote_name")
270 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
271 expr "$head" : "$_x40\$" >/dev/null ||
272 die "Failed to fetch $remote_name from $remote"
273 echo >&2 Fetching "$remote_name from $remote" using http
274 git-http-fetch -v -a "$head" "$remote/" || exit
275 ;;
276 rsync://*)
277 TMP_HEAD="$GIT_DIR/TMP_HEAD"
278 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
279 head=$(git-rev-parse --verify TMP_HEAD)
280 rm -f "$TMP_HEAD"
281 test "$rsync_slurped_objects" || {
282 rsync -av --ignore-existing --exclude info \
283 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
Junio C Hamano853a3692005-08-20 02:54:34 -0700284
Junio C Hamano03febf92006-01-07 00:48:04 -0800285 # Look at objects/info/alternates for rsync -- http will
286 # support it natively and git native ones will do it on
287 # the remote end. Not having that file is not a crime.
288 rsync -q "$remote/objects/info/alternates" \
289 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
290 rm -f "$GIT_DIR/TMP_ALT"
291 if test -f "$GIT_DIR/TMP_ALT"
292 then
293 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
294 while read alt
295 do
296 case "$alt" in 'bad alternate: '*) die "$alt";; esac
297 echo >&2 "Getting alternate: $alt"
298 rsync -av --ignore-existing --exclude info \
299 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
300 done
301 rm -f "$GIT_DIR/TMP_ALT"
302 fi
303 rsync_slurped_objects=t
304 }
305 ;;
306 *)
307 # We will do git native transport with just one call later.
308 continue ;;
309 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700310
Junio C Hamano03febf92006-01-07 00:48:04 -0800311 append_fetch_head "$head" "$remote" \
312 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
Junio C Hamano853a3692005-08-20 02:54:34 -0700313
Junio C Hamano03febf92006-01-07 00:48:04 -0800314 done
315
316 case "$remote" in
317 http://* | https://* | rsync://* )
318 ;; # we are already done.
319 *)
320 ( : subshell because we muck with IFS
321 IFS=" $LF"
322 (
Junio C Hamanob19696c2006-02-20 00:38:39 -0800323 git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
Junio C Hamano03febf92006-01-07 00:48:04 -0800324 ) |
325 while read sha1 remote_name
326 do
327 case "$sha1" in
328 failed)
329 echo >&2 "Fetch failure: $remote"
330 exit 1 ;;
331 esac
332 found=
333 single_force=
334 for ref in $refs
335 do
336 case "$ref" in
337 +$remote_name:*)
338 single_force=t
339 not_for_merge=
340 found="$ref"
341 break ;;
342 .+$remote_name:*)
343 single_force=t
344 not_for_merge=t
345 found="$ref"
346 break ;;
347 .$remote_name:*)
348 not_for_merge=t
349 found="$ref"
350 break ;;
351 $remote_name:*)
352 not_for_merge=
353 found="$ref"
354 break ;;
355 esac
356 done
357 local_name=$(expr "$found" : '[^:]*:\(.*\)')
358 append_fetch_head "$sha1" "$remote" \
359 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
360 done
361 ) || exit ;;
362 esac
363
364}
365
366fetch_main "$reflist"
367
368# automated tag following
369case "$no_tags$tags" in
370'')
371 taglist=$(IFS=" " &&
Michal Ostrowski96b086d2006-01-20 13:38:16 -0500372 git-ls-remote $upload_pack --tags "$remote" |
Junio C Hamano03febf92006-01-07 00:48:04 -0800373 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
374 while read sha1 name
Junio C Hamano853a3692005-08-20 02:54:34 -0700375 do
Junio C Hamano03febf92006-01-07 00:48:04 -0800376 test -f "$GIT_DIR/$name" && continue
377 git-check-ref-format "$name" || {
378 echo >&2 "warning: tag ${name} ignored"
379 continue
380 }
381 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
382 echo >&2 "Auto-following $name"
383 echo ".${name}:${name}"
384 done)
385 case "$taglist" in
386 '') ;;
387 ?*)
388 fetch_main "$taglist" ;;
389 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700390esac
Junio C Hamanob10ac502005-08-25 18:15:32 -0700391
392# If the original head was empty (i.e. no "master" yet), or
393# if we were told not to worry, we do not have to check.
394case ",$update_head_ok,$orig_head," in
395*,, | t,* )
396 ;;
397*)
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700398 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
Junio C Hamanob10ac502005-08-25 18:15:32 -0700399 if test "$curr_head" != "$orig_head"
400 then
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700401 git-update-ref HEAD "$orig_head"
Junio C Hamanob10ac502005-08-25 18:15:32 -0700402 die "Cannot fetch into the current branch."
403 fi
404 ;;
405esac